use [TemporalSnapshotFact]
go

create view etl.vw_dates
as
with cte as
(
	select
		dt = cast('20090101' as datetime) + n - 1
	from
		util.[fn_Nums](datediff(day, '20090101', '20111231') + 1)
)
select
	id_date = year(dt) * 10000 + month(dt) * 100 + day(dt),
	[date] = cast(dt as date),
	day_of_month = datepart(dd, dt),
	day_name = datename(dw, dt),
	month_of_year = month(dt),
	month_name = datename(month, dt), 
	[year] = year(dt)
from
	cte
go
