use [TemporalSnapshotFact]
go

create view etl.vw_daterange_items_first_day_of_year
as
with src AS
(
	select
		item_id
	,	min_valid_from = MIN(valid_from)
	,	max_valid_to = MAX(valid_to)
	,	diffdate = CASE
						WHEN MAX(valid_to) = '99991231' THEN DATEDIFF(YEAR, MIN(valid_from), GETDATE() + 1)
						ELSE DATEDIFF(YEAR, MIN(valid_from), MAX(valid_to))
					END
		
	from
		tmp.daterange_items_all_ranges dr
	group by
		item_id
)
select
	src.item_id
,	first_of_year = cast(CAST(YEAR(src.min_valid_from) + num.n as CHAR(4)) + '0101' as date)
from src
	inner join util.fn_nums(1000) num
		on num.n <= src.diffdate
where src.max_valid_to <> cast(CAST(YEAR(src.min_valid_from) + num.n as CHAR(4)) + '0101' as date)