use [TemporalSnapshotFact]
go

create view etl.vw_items_exploded
as
select
	i.item_id,
	i.[status],	
	r.valid_from,
	r.valid_to
from
	staging.[items] i
inner join
	tmp.[daterange_items_new_ranges] r on i.item_id = r.item_id
where
	(r.valid_from >= i.valid_from and r.valid_to <= i.valid_to)
go

create view etl.vw_subitems_exploded
as
select
	s.item_id,
	s.subitem_id,
	s.[status],
	r.valid_from,
	r.valid_to,
	s.[value]
from
	staging.[subitems] s
inner join
	tmp.[daterange_items_new_ranges] r on s.item_id = r.item_id
where
	(r.valid_from >= s.valid_from and r.valid_to <= s.valid_to)
go