use [TemporalSnapshotFact]
go

create view [olap].[vw_dim_daterange]
as
select
    id_date_range = 
    cast(convert(char(8), valid_from, 112)
    + right(convert(char(8), valid_to, 112), 4) as bigint)
  , valid_from
  , valid_to
from
    tmp.[daterange_all_new_ranges]
go

create view [olap].[vw_fact_items]
as
select
	id_date_range = CAST(CONVERT(CHAR(8), [valid_from], 112) + RIGHT(CONVERT(CHAR(8), [valid_to], 112), 4) AS BIGINT),
	[item_id],
	[status]
from
	tmp.items_exploded
go

create view [olap].[vw_fact_subitems]
as
select
	id_date_range = CAST(CONVERT(CHAR(8), se.[valid_from], 112) + RIGHT(CONVERT(CHAR(8), se.[valid_to], 112), 4) AS BIGINT),
	se.[item_id], 
	se.[subitem_id], 
	subitem_status = se.[status], 
	item_status = ie.[status],
	se.[value]
from
	tmp.[subitems_exploded] se
inner join
	tmp.[items_exploded] ie on se.[item_id] = ie.[item_id] and se.[valid_from] = ie.[valid_from] and se.[valid_to] = ie.[valid_to]
go

create view [olap].[vw_bridge_date_datarange]
as
select
    d.id_date, 
    id_date_range = cast(convert(char(8), dr.valid_from, 112) + right(convert(char(8), dr.valid_to, 112), 4) as bigint), 
    valid_from = dr.valid_from, 
    valid_to = dr.valid_to
from
    etl.vw_dates d
    inner join tmp.daterange_all_new_ranges dr
        on d.[date] >= dr.valid_from and d.[date] < dr.valid_to        
go


create view [olap].[vw_dim_date]
as
select
	id_date,
	[date],
	[month_of_year],
	month_label = month_name + ' ' + cast(year as char(4)),
	[year]
from
	etl.vw_dates
go


create view [olap].vw_dim_item
as
with cte as
(
	select 
		item_id,
		subitem_id = null
	from
		[staging].[subitems]

	union

	select 
		item_id,
		subitem_id
	from
		[staging].[subitems]
)
select
	label_item = cast(item_id as varchar(2)),
	label_subitem = cast(item_id as varchar(2)) + isnull('.' + cast(subitem_id as varchar(2)), ''),
	*
from
	cte
go


create view [olap].vw_dim_status
as
select 
	[status]
from
	[staging].[items]	
	
union 
	
select 
	[status]
from
	[staging].[subitems]	
go