use TemporalSnapshotFact
go

create view [olap].[vw_fact_items_daily_snapshot]
as
with cte as
(
	select
		*,
		dayspan = datediff(day, valid_from, isnull(nullif(valid_to, '99991231'), '20111231')) + 1
	from
		staging.items	
	)
select
    [c].[item_id]
,   [c].[status]
,   [c].[valid_from]
,   [c].[valid_to]
,	snapshot_date = dateadd(day, n.n - 1, valid_from)
from
	cte c
inner join
	util.[fn_Nums](366*100) n on dateadd(day, n.n - 1, c.valid_from) between c.[valid_from]  and c.[valid_to]

GO

create view [olap].[vw_fact_subitems_daily_snapshot]
as
with cte as
(
	select
		*,
		dayspan = datediff(day, valid_from, isnull(nullif(valid_to, '99991231'), '20111231')) + 1
	from
		staging.subitems	
	)
select
    [c].[item_id]
,   [c].[subitem_id]
,   [c].[status]
,   [c].[valid_from]
,   [c].[valid_to]
,   [c].[value]
,	snapshot_date = dateadd(day, n.n - 1, valid_from)
from
	cte c
inner join
	util.[fn_Nums](366*100) n on dateadd(day, n.n - 1, c.valid_from) between c.[valid_from]  and c.[valid_to]

GO


