@echo off

set sqlsrv=localhost

echo Setting up the database...
sqlcmd -S %sqlsrv% -E -i 00.setup.sql
if %ERRORLEVEL% NEQ 0 goto errors

echo Creating ETL objects (1/2)...
sqlcmd -S %sqlsrv% -E -i 02.create-etl-objects-1.sql
if %ERRORLEVEL% NEQ 0 goto errors

echo Creating datarange tables...
sqlcmd -S %sqlsrv% -E -i 03a.create-tmp-datarange-tables.sql
if %ERRORLEVEL% NEQ 0 goto errors

echo Creating ETL objects (2/2)...
sqlcmd -S %sqlsrv% -E -i 03b.create-etl-objects-2.sql
if %ERRORLEVEL% NEQ 0 goto errors

echo Creating exploded views...
sqlcmd -S %sqlsrv% -E -i 04.create-exploded-views.sql
if %ERRORLEVEL% NEQ 0 goto errors

echo Creating exploded tables...
sqlcmd -S %sqlsrv% -E -i 05.create-exploded-tmp-tables.sql
if %ERRORLEVEL% NEQ 0 goto errors

echo Creating olap views...
sqlcmd -S %sqlsrv% -E -i 06.create-olap-objects.sql
if %ERRORLEVEL% NEQ 0 goto errors

echo Creating daily snapshots views...
sqlcmd -S %sqlsrv% -E -i 09.create-daily-snapshot-views.sql
if %ERRORLEVEL% NEQ 0 goto errors

:noerrors
echo Batch Done.
goto end

:errors
echo Error during batch execution!

:end
pause
